<component-section>
  <div slot="title">Studiehandleiding</div>
  <component-section>
    <div slot="title">Inleiding</div>
    <p>
      Van vaklui tot gebruikers: iedereen heeft een mening over de
      <em>prestatie-efficiëntie</em> (performance efficiency) van software. Hoe kan het dat populaire software soms toch
      niet vooruit te branden is? Komt het door (verkeerde?) ontwerpbeslissingen op een hoog abstractieniveau, is the
      devil in the details, of ligt het aan iets anders? Jij bent een freelance softwarearchitectuurconsultant, en jij
      gaat de uitdaging aan om dit probleem op te lossen voor een bepaald softwaresysteem.
    </p>
    <p>In Onderzoek naar performance leer en beoefen je vaardigheden waarover je kennis hebt opgedaan in SKA en ADP.</p>
    <component-section>
      <div slot="title">Professioneel werken in je eigen omgeving</div>
      <p>
        Het ASD-docententeam wil dat ASD goed aansluit bij de behoeftes op jouw werk en/of bij je vakinteresses. De
        opdracht is voor een belangrijk deel vrij in te vullen. Je werkt zelfstandig en zoals in het echt. Deze opdracht
        is met andere woorden een <em>werkplekopdracht</em>.
      </p>
    </component-section>
    <component-section>
      <div slot="title">Softwarearchitectuur + algoritmes en datastructuren = softwarekwaliteit?</div>
      <p>
        🏛️ Softwarearchitectuur in samenhang bekijken met 🧮 algoritmes en datastructuren is extra leerzaam. SKA en ADP
        gaan over twee ogenschijnlijk ver van elkaar staande kennisgebieden, maar in ASD leer je gaandeweg dat je beide
        prima kunt integreren om efficiëntere en effectievere softwaresystemen op te leveren. ✅ Softwarekwaliteit vormt
        de brug tussen SKA en ADP.
      </p>
    </component-section>
  </component-section>
  <component-section>
    <div slot="title">Toetsen</div>
    <figure>
      <figcaption>
        De bovenste rij staat voor de voltijdse tegenhanger van OP. De onderste voor OP zelf. De
        <strong>kolommen</strong> staan voor de onderwijsjaren waarin de course is uitgevoerd. De titels van de
        <strong>cellen</strong> staan voor de code van de desbetreffende course. De <strong>vormen</strong> staan voor
        specifieke deeltentamens, aangeduid met hun code. De <strong>pijlen</strong> tussen cellen staan voor
        veranderingen aan de toetsstructuur. De <strong>dikte van de pijlen</strong> staat voor hoe groot het aandeel
        van de oorspronkelijke toets is in de nieuwe toets. Alle deeltentamens die geconverteerd worden wegen gelijk,
        tenzij de pijldikte verschilt. Conversies met verschillende pijldikte zijn nog niet voorgekomen.
      </figcaption>
      <img src="svg/Mutaties_toetsstructuur_project.min.svg" alt="Mutaties toetsstructuur project" />
    </figure>
    <component-section>
      <div slot="title">Presentatie over je keuze van softwaresysteem voor het onderzoek (<code>Ass_Pres</code>)</div>
      <component-section>
        <div slot="title">Doel</div>
        <p>Presenteer maximaal tien minuten over het softwaresysteem dat je gaat onderzoeken.</p>
        <p>
          Het softwaresysteem moet voldoen aan een aantal criteria ten aanzien van onder andere kwaliteit en schaal.
          Maar los daarvan, begin je natuurlijk vanuit de behoefte van je opdrachtgever. Waarom is performance relevant
          voor dit systeem? En dan specifiek voor bepaalde use-cases?
        </p>
        <p>
          In het beoordelingsformulier staan een aantal vormcriteria. De 10 000 regels kan je meten broncode met
          <a href="https://github.com/XAMPPRocky/tokei">Tokei</a>. Let erop dat de ontwikkeling van het systeem
          kwalitatief goed uitgevoerd is, en dat het systeem ook nu nog onderhouden wordt. De productkwaliteit kan je
          onder meer afleiden uit het voldoen aan onder andere de OOSE-richtlijnen, en/of bijvoorbeeld de aanwezigheid
          van een degelijke geautomatiseerde test suite, API-/commentaardocumentatie en een uniforme broncodestijl.
        </p>
        <p>
          Er zijn ook criteria wat betreft je communicatie met belanghebbenden en in hoeverre je aantoont dat zij waarde
          hechten aan je onderzoek. Ga zo snel mogelijk na welke informatie je bijvoorbeeld met bijvoorbeeld
          <a href="https://onderzoek.hbo-i.nl/index.php/Interview">interviews</a>
          nog moet ophalen bij deze belanghebbenden. Als je andere betrouwbare bronnen hebt die je methodisch gebruikt,
          kan je de benodigde communicatie met de belanghebbenden vast wel beperken. In de praktijk verwachten je
          beoordelaars dat je vooral navraag moet doen bij belanghebbenden als het gaat om de
          <em>inhoud van de performance-qar's</em>. ‘Hoe snel moet het zijn?’ Wat jij voor vereisten in gedachten hebt,
          hoeft niet de bedoeling van opdrachtgever, architect of andere belanghebbenden te zijn geweest.
        </p>
        <p><strong>💡 1</strong>: Hoe zorgvuldig en snel je kiest heeft grote invloed op je kans van slagen voor OP.</p>
        <p>
          <strong>💡 2</strong>: Vermijd hobbyprojecten en te complexe softwaresystemen. Kies een relevant systeem voor
          jezelf en een noemenswaardige groep belanghebbenden (community), bijvoorbeeld:
        </p>
        <ul>
          <li>
            <p>één van je organisatie.</p>
          </li>
          <li>
            <p>
              <em>desnoods</em> één voor jou al ruim bekend en actief ontwikkeld opensourceproject met een community
              (zie bijvoorbeeld: <cite data-id="6867189/L2HPPLN7"></cite><cite data-id="6867189/YD7G37U3"></cite>);
            </p>
          </li>
        </ul>
        <p>
          <strong>💡 3</strong>: Je moet de implementatie heel goed kunnen doorgronden, en dat in korte tijd. Kies een
          softwaresysteem ontwikkeld in een jou bekende programmeertaal en voor een jou bekend toepassingsdomein.
        </p>
      </component-section>
      <component-section>
        <div slot="title">In te leveren</div>
        <p>
          Neem je presentatie op (met beeld en geluid). Dat kan bijvoorbeeld met
          <a href="https://web.microsoftstream.com/studio">Microsoft Stream</a> binnen de HAN-Office 365-omgeving.
        </p>
        <p>
          Lever je presentatievideo in op
          <a href="https://www.han.nl/onderwijsondersteuning/tools/video-videotoetsing/index.xml"
            >videotoetsing.han.nl</a
          >. Pas zodra je video op videotoetsing.han.nl staat heb je het officieel ingeleverd. Stuur de videohyperlink
          door naar je beoordelaars. Deze hyperlink ontvang je per e-mail van videotoetsing.han.nl, na enige wachttijd.
        </p>
      </component-section>
      <component-section>
        <div slot="title">Beoordeling</div>
        <p>
          Zie het
          <a
            href="bron/Beoordelingsmodel%20%C2%B7%20Presentatie%20over%20je%20keuze%20van%20softwaresysteem%20voor%20het%20onderzoek%20(Ass_Pres).pdf"
            >beoordelingsformulier</a
          >. \(\text{cijfer} = 9 * (\text{punten} / \text{totaal}) + 1\), minimaal 1 en maximaal 10. Voor de weging van
          dit deeltentamen en overige examineringsinformatie, zie
          <a
            href="https://isas.han.nl/Default.aspx?F=OnderwijsAanbodDetails&Studiejaar=2021&Eigenaar=AIM&OWE=ASD+OP&Back=A&dt=211700997"
            >iSAS</a
          >.
        </p>
      </component-section>
    </component-section>
    <component-section>
      <div slot="title">Onderzoek naar performance (<code>B_ond_per</code>)</div>
      <component-section>
        <div slot="title">Beschrijving</div>
        <p>
          Je opdracht is het uitvoeren van een onderzoek ten aanzien van performance aan een softwaresysteem. Je
          opdrachtgever en lezer is een denkbeeldige hoofdarchitect voor het systeem. Het doel van je onderzoek is het
          vaststellen in hoeverre het systeem voldoet aan redelijke kwaliteitsvereisten te aanzien van performance, en
          voor zover niet, wat de oplossingsrichting is voor de gevonden knelpunten.
        </p>
        <p>
          Het onderzoek gaat over compleet softwaresysteem. Je beperken tot specifieke modules en microbenchmarking is
          niet de bedoeling. Wel mag je subsystemen (vaak ≈ grote packages) benoemen, waar je aandacht aan besteed naar
          gelang hun belang voor de qas’en die je meeneemt in je onderzoek. Uiteraard moet je een echte
          performanceproblemen oplossen en mag je niet alleen constateren dat alles al goed is.
        </p>
        <p>Het komt neer op de volgende stappen</p>
        <ol>
          <li>
            <p>Kies een geschikt softwaresysteem. Dit heb je voor de presentatie al gedaan.</p>
          </li>
          <li>
            <p>
              Achterhaal het architectuurontwerp van het softwaresysteem. Gebruik een zelfgeschreven SAD of een extern
              SAD. Stel de
              <em class="term">quality attribute requirements (qars) over performance</em>
              vast van dit softwaresysteem. Vul het SAD desnoods een met ten minste
              <em class="term">quality attribute scenario’s (qas’en) over performance</em>
              in tabelvorm bevat.
            </p>
          </li>
          <li>
            <p>Analyseer of deze qas’en behaald worden.</p>
          </li>
          <li>
            <p>Nu je alle informatie hebt verzameld: beantwoord de onderzoeksvragen.</p>
          </li>
          <li>
            <p>Implementeer verbeteringen aan de broncode per qas.</p>
          </li>
        </ol>
        <component-section>
          <div slot="title">De vaste inhoud van het onderzoeksrapport</div>
          <p>
            Houd
            <a href="https://maken.wikiwijs.nl/156099/1_1_6_Onderzoeksrapport_schrijven__basis_#!page-5769348"
              >de richtlijnen van Saxion voor HBO-i</a
            >
            aan, inclusief de <em>exacte structuur</em> qua hoofdstukken en paragrafen.
          </p>
          <component-section>
            <div slot="title">Onderzoeksvragen</div>
            <p>De hoofdvraag is: hoe kunnen alle qas’en van het softwaresysteem behaald worden?</p>
            <p>Beantwoord eerst de volgende deelvragen <em>per</em> performance-qas:</p>
            <ol>
              <li>
                <p>Hoe beïnvloedt het gebruik van (standaard)algoritmes en -datastructuren het behalen van deze qas?</p>
              </li>
              <li>
                <p>Hoe beïnvloedt het architectuurontwerp het behalen van deze qas?</p>
              </li>
              <li><p>Welke verbeteringen aan de broncode zijn aan te raden voor het behalen van deze qas?</p></li>
            </ol>
          </component-section>
          <component-section>
            <div slot="title">Methoden</div>
            <p>
              Je zal vele methoden toepassen, zoals interviews, desk research, broncodeanalyse, algoritmeanalyse,
              geautomatiseerde performance tests. Verwijs waar mogelijk naar de ICT Research Methods
              <cite data-id="6867189/WWDFSZKG"></cite>, zoals de non-functional test. Heb je dus andere
              onderzoeksmethoden uit de ICT Research Methods toegepast, benoem die dan ook.
            </p>
            <p>
              <strong>💡Tip 4</strong>: Zorg er ook voor dat je alleen broncode hoeft te analyseren geschreven in een
              programmeertaal waarvoor voldoende hulpmiddelen zijn. Denk aan dit soort tools:
            </p>
            <ul>
              <li>
                <p class="bron">
                  <a href="https://en.wikipedia.org/wiki/List_of_performance_analysis_tools"
                    >List of performance analysis tools</a
                  >.
                </p>
              </li>
              <li>
                <p>
                  Microsoft
                  <a href="https://github.com/Microsoft/ApplicationInspector">Application Inspector</a>.
                </p>
              </li>
            </ul>
          </component-section>
          <component-section>
            <div slot="title">Materialen</div>
            <p>Beschrijf hoe je de volgende materialen hebt gebruikt (op wat voor manier dan ook):</p>
            <ol>
              <li>Alle broncode van alle onderzochte softwaresystemen.</li>
              <li>Alle testbroncode van alle onderzochte softwaresystemen.</li>
              <li>
                Alle bronnen die je gebruikt hebt (denk aan technische documentatie, communicatie van het ontwikkelteam,
                requirements-gerelateerde informatie vanuit opdrachtgevers).
              </li>
              <li>Het SAD.</li>
              <li>Kwaliteitsvereisten.</li>
              <li>De qas’en, zowel schriftelijk als in de vorm van geautomatiseerde tests.</li>
            </ol>
          </component-section>

          <component-section>
            <div slot="title">Bronnen</div>
            <p>
              Gebruik de IEEE-verwijzingsstijl
              <cite data-id="6867189/36G9SCWF"></cite>.
            </p>
          </component-section>
        </component-section>
      </component-section>
      <component-section>
        <div slot="title">In te leveren</div>
        <p>Lever uiteindelijk in op de deadline van je toetsrooster, ingepakt als ZIP-bestand, via iSAS:</p>
        <ol>
          <li>Alle opgesomde materialen, voor zover gebruikt/gemaakt.</li>
          <li>Broncode van prototypes of andere bijlages die je relevant vindt.</li>
          <li>Je presentatie.</li>
          <li>Het onderzoeksrapport.</li>
        </ol>
      </component-section>
      <component-section>
        <div slot="title">Beoordeling</div>
        <p>
          Zie het
          <a href="bron/Beoordelingsmodel%20%C2%B7%20Onderzoek%20naar%20performance%20(B_ond_per).pdf"
            >beoordelingsformulier</a
          >. \(\text{cijfer} = 9 * (\text{punten} / \text{totaal}) + 1\), minimaal 1 en maximaal 10. Voor de weging van
          dit deeltentamen en overige examineringsinformatie, zie
          <a
            href="https://isas.han.nl/Default.aspx?F=OnderwijsAanbodDetails&Studiejaar=2021&Eigenaar=AIM&OWE=ASD+OP&Back=A&dt=211700997"
            >iSAS</a
          >.
        </p>
        <p>
          Het is van groot belang dat je resultaten reproduceerbaar en je rapportage en broncode begrijpelijk zijn. Pas
          agressief tools toe die je broncode verbeteren (formatters, linters, static analysis tools), zodat je
          beoordelaar en jijzelf meteen goed snappen hoe je broncode werkt. Als je je tests/kwaliteitscontroles ook
          online uitvoert als CI/CD (GitLab CI, GitHub Actions, enzovoort), is het voor je beoordelaar ook sneller
          duidelijk hoe jouw tests lokaal gedraaid kunnen worden.
        </p>
      </component-section>
    </component-section>
  </component-section>
</component-section>
